package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import java.util.*;
import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;

public abstract aspect LoDPointCutsContext extends Allowed {
  abstract pointcut positiveSituationsContext();
  public static Stack stackPrefSuppliers = new Stack();
  public static HashSet prefSuppliers = new HashSet();

  before() : Any.Execution() {
  	stackPrefSuppliers.push(prefSuppliers);
        prefSuppliers = new HashSet();
  }
  before() : positiveSituationsContext() {
    Class[] allowed=getAllowed(thisEnclosingJoinPointStaticPart, thisJoinPointStaticPart);
    if(allowed!=null && allowed.length!=0){
       prefSuppliers.addAll(Arrays.asList(allowed));
    }
  }
  after(): Any.Execution() {
  	prefSuppliers = (HashSet)stackPrefSuppliers.pop();
  }

  public static void showPrefSuppliers(){
    System.out.println(prefSuppliers.toString().replace(',','\n'));
  }
}
