package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import java.util.*;
import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;

public aspect Arguments extends LoDPointCutsContext {

  pointcut positiveSituationsContext(): Any.Execution();

  Class[] getAllowed(JoinPoint.StaticPart ejsp,JoinPoint.StaticPart jsp) {
      // CORRECTED CODE - arguments did not include the this/self class
      //                  also change in Any.Execution to include constructors
      //                  required change in cast from MethodSignature to CodeSignature
         Class[] methArgs = ((CodeSignature)jsp.getSignature()).getParameterTypes();
         Vector allArgs = new Vector();
         allArgs.addAll(Arrays.asList(methArgs));
         allArgs.add( jsp.getSignature().getDeclaringType() );    // add this/self
         return (Class[])allArgs.toArray(methArgs);
//        return ((MethodSignature)jsp.getSignature()).getParameterTypes();
      // END CORRECTED CODE
  }


}

