package lawOfDemeter;

import org.aspectj.lang.*;

public class JPUtil {

  protected static String at(JoinPoint.StaticPart ejsp, JoinPoint jp) {
    Object targetObj = jp.getTarget();
    Class targetType = null;
    if(targetObj != null){
      targetType = jp.getTarget().getClass();
    }
    return " at "
      + jp.getSourceLocation().getFileName() + ":"
      + jp.getSourceLocation().getLine() + ":"
      + jp.getSourceLocation().getColumn() + " this "
      + ejsp.getSignature().getDeclaringType() + " target "
      + targetType + " (declaringTarget "
      + jp.getSignature().getDeclaringType() + ")";
  }

}
