package lawOfDemeter;

/**
 * @author Pengcheng Wu
 */

import java.util.*;
import org.aspectj.lang.reflect.*;
import org.aspectj.lang.*;


public abstract aspect LoDPointCutsGlobal extends Allowed {
  abstract pointcut positiveSituationsGlobal();

  public static HashMap prefSuppliers = new HashMap();

  before(): positiveSituationsGlobal() {
    // key: java.lang.Class object representing the class, interface, or aspect that declared this member
    // object: Class[]
      prefSuppliers.put(thisJoinPointStaticPart.getSignature().getDeclaringType(),
        getAllowed(thisEnclosingJoinPointStaticPart,thisJoinPointStaticPart));
  }

  public static void showPrefSuppliers(){
    System.out.println(prefSuppliers.toString().replace(',','\n'));
  }
}
